
!****************************************************************************

!        1         2         3         4         5         6         7 !
! 3456789012345678901234567890123456789012345678901234567890123456789012345678
!      program Fortran Demo

#ifdef BOINC
#ifdef BOINC_WIN32
! to use it w/ BOIN under windows, it needs to be called as a subroutine
! this implements this call.

      INTEGER FUNCTION WinMain(hI, hPI, lpszCL, nShow)

      IMPLICIT REAL*8 (A-H)
      IMPLICIT INTEGER (I-Z)

      INTEGER:: hI, hPI, lpszCL, nShow

      CALL DEMO ()
      WinMain = 0

      END FUNCTION WinMain
!
      SUBROUTINE DEMO
#else
      PROGRAM DEMO
#endif 

#else 
      PROGRAM DEMO
      use aranzy_mod
#endif 

      implicit integer(i-z)

#ifdef BOINC
! code to implement BOINC and BOIN on Windows enabled code.
!##.not.BOINC_WIN32
      external cboincinit
      external cboincfinish  
      external cboincisstandalone
      external cboincresolvefilename
      external cboincfractiondone
      external cboinctimetocheck
      external cboinccheckcompleted

#ifdef BOINC_WIN32
! code to implement BOINC and BOIN on Windows enabled code.

! cboincinit ( )

      INTERFACE
      SUBROUTINE cboincinit ( )

      !DEC$ ATTRIBUTES C :: cboincinit

      END SUBROUTINE cboincinit
      END INTERFACE

! cboincisstandalone ( )

      INTERFACE
      SUBROUTINE cboincisstandalone (isstandalone)

      !DEC$ ATTRIBUTES C :: cboincisstandalone

      INTEGER isstandalone

      END SUBROUTINE cboincisstandalone
      END INTERFACE

! cboincresolvefilename(infile, inpath, lengthin, lengthout)

       INTERFACE
       SUBROUTINE cboincresolvefilename (infile,inpath,length,lengthout)

       !DEC$ ATTRIBUTES C :: cboincresolvefilename

       CHARACTER*(*) infile, inpath
       INTEGER lengthin, lengthout 

       !DEC$ ATTRIBUTES REFERENCE :: infile, inpath

       END SUBROUTINE cboincresolvefilename
       END INTERFACE

! cboincfinish (exitstatus)

      INTERFACE
      SUBROUTINE cboincfinish (exitstatus)

      !DEC$ ATTRIBUTES C :: cboincfinish

      INTEGER exitstatus

      END SUBROUTINE cboincfinish
      END INTERFACE

! cboincfractiondone (prcdon)

      INTERFACE
      SUBROUTINE cboincfractiondone (prcdon)

      !DEC$ ATTRIBUTES C :: cboincfractiondone

      REAL*8 prcdon

      END SUBROUTINE cboincfractiondone
      END INTERFACE

! cboinctimetocheckpoint ()

      INTERFACE
      SUBROUTINE cboinctimetocheckpoint ( docheck )

      !DEC$ ATTRIBUTES C :: cboinctimetocheckpoint

!      CHARACTER*(*) docheck
      INTEGER docheck

      !DEC$ ATTRIBUTES REFERENCE :: docheck

      END SUBROUTINE cboinctimetocheckpoint
      END INTERFACE

!  cboinccheckpointcompleted ()

      INTERFACE
      SUBROUTINE cboinccheckcompleted ()

      !DEC$ ATTRIBUTES C :: cboinccheckpointcompleted

      END SUBROUTINE cboinccheckcompleted
      END INTERFACE

#endif  
#endif  


#ifndef BOINC
      if(restart)then
        write(20,*) 'DEMO: this is a restart'
      else
        write(20,*) 'DEMO: this is a new run'
      endif
#endif

#ifdef BOINC
#ifdef debug
      write(20,*)'DEMO: calling boinc_init'
#endif
      CALL cboincinit() 
      CALL cboincisstandalone(ISSTANDALONE) 
! This ensures that volunteer's cannot use it and that it only 
!  runs through the C BOINC client. For purposes of running tests define debug (-Ddebug)
#ifdef debug
      ISSTANDALONE = 0 !don't worry, we're just debugging
#endif
      IF (ISSTANDALONE.EQ.1) THEN
         write(20,*)'DEMO: Im standalone!'
         write(20,*)'DEMO: I can not run like this'
      ELSE
#ifdef debug
          write(20,*)'DEMO: Im inside BOINC, lets rock!'
#endif
      ENDIF
#endif


#ifdef BOINC
      CALL cboincfractiondone(0.0D0)
#endif

#ifdef BOINC
           CALL cboincfractiondone(APRCDON)
#endif       

!cccccccccccccccc do checkpointing cccccccccccccccccccc
      if(ichkpntcnt.eq.ichkpnt)then
!        write(*,*) '  Checkpointing'
      ENDIF
#ifdef BOINC
! maybe we don't need to ask, since ...
      CALL cboinctimetocheckpoint(docheck) 
#endif


#ifdef BOINC
! OK BOINC, you can kill us if you want to, we're ready!
      CALL cboinccheckcompleted()

#endif
!cccccc=======================================================cccccccccc
!c          The main program ended!
!cccccc=======================================================cccccccccc










!                   G       L     O      B     A    L

! FFFFF   U   U   N   N   CCCCC   TTTTT   I   OOOOO   N    N   SSSSS
! F       U   U   N   N   C         T     I   O   O   N    N   S
! FFFF    U   U   NN  N   C         T     I   O   O   NN   N   SSSSS
! F       U   U   N N N   C         T     I   O   O   N N  N       S
! F       U   U   N  NN   C         T     I   O   O   N  N N       S
! F       UUUUU   N   N   CCCCC     T     I   OOOOO   N   NN   SSSSS

!                     B       E     L      O      W






!ccccccccccccccccccccccccccccccccccccccccccccccccccccccc
#ifdef BOINC
      CALL cboincfractiondone(1.0D0)
      CALL cboincfinish(0) 
#endif
      STOP 0
      end


